;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@LastK=4025
@DFile=400C
@DFxCC=400E
@Spare1=4021			;16417, Car position

ORG 4084

	JR Collision		;16516
	JR WaitYN		;16518
	JR PrintCar		;16520

@Collision
	LD BC,0076
	LD DE,0021
	LD HL,(DFxCC)
	LD A,(HL) 
	CP C
	JR Z +2
	OR A 
	RET NZ 
	ADD HL,DE 
	LD A,(HL) 
	CP C
	JR Z +2
	OR A 
	RET NZ 
	ADD HL,DE 
	LD A,(HL) 
	CP C
	JR Z +2
	OR A 
	RET NZ 
	LD C,00 
	RET
;==========================
; Scroll Up
;==========================
@ScrollUp
	LD HL,(DFile)
	LD D,H
	LD E,L
	LD C,0021 
	ADD HL,BC 
	LD BC,02F7 
	LDIR
	LD C,21
	SBC HL,BC
	LD C,B
	LD B,20 
	INC HL 
	LD (HL),C
	DJNZ -4
	RET
;================================
;WaitYN
;
; Wait for Y/N response
;================================
@WaitYN
	LD A,(LastK)		;Get key section value
	CP FF			;Key press test
	JR NZ WaitYN		;Loop if key being depressed
	LD BC,0000		;Set return value to 0
@YNLoop
	LD A,(LASTK)		;Get key section value
	CP DF	 		;Section 5? Keys Y to P
	JR NZ +2		;Jump if not section 5
	INC C			;Set BC for return
	RET			;Return 1 to BASIC
	CP 7F	 		;Section 7?, Keys B to space
        RET Z			;Return 0 to BASIC
	JR YNLoop		;Loop until section 5 (Y) or 7 (N) key pressed
;================================
;Print car
;================================
@PrintCar
	LD HL,(DFxCC)		;First erase walker
	LD (HL),00
	LD BC,0021
	ADD HL,BC
	LD (HL),00
	ADD HL,BC
	LD (HL),00
	LD HL,(DFile)		;Print car
	LD BC,02F8
	ADD HL,BC
	LD B,00
	LD C,(IY+33)		;Get Xcoord
	ADD HL,BC
	PUSH HL
	LD (HL),90		;Print "()>"
	INc HL
	LD (HL),91
	INc HL
	LD (HL),92
	CALL ScrollUp
	POP HL
	PUSH HL
	LD (HL),A0		;Print "456"
	INc HL
	LD (HL),A1
	INc HL
	LD (HL),A2
	CALL ScrollUp
	POP HL
	LD (HL),B0		;Print "KLM"
	INc HL
	LD (HL),B1
	INc HL
	LD (HL),B2
	LD C,00
	RET

